#include "strerr.h"
#include "env.h"
#include "subscribe.h"
#include "errtxt.h"

#define FATAL "ezmlm-issubn: fatal: "

void die_usage()
{
  strerr_die1x(100,"ezmlm-issubn: usage: ezmlm-issubn [-nN] dir [dir1 ...]");
}

void die_sender()
{
  strerr_die2x(100,FATAL,ERR_NOSENDER);
}

void main(argc,argv)
int argc;
char **argv;
{
  char *dir;
  char *addr;
  int flagsub = 0;
  int optind = 1;

  addr = env_get("SENDER");
  if (!addr) die_sender();	/* REQUIRE sender */

  if (argv[1][0] == '-') {
    if (argv[1][1] == 'n')
      flagsub = 99;
    else if (argv[1][1] != 'N')
      die_usage();
    optind = 2;
  }

  dir = argv[optind];
  if (!dir) die_usage();

  while ((dir = argv[optind++])) {
    if (dir[0] != '/')
      strerr_die2x(100,FATAL,ERR_SLASH);
    if (issub(dir,addr,FATAL))
      _exit(flagsub);		/* subscriber */
  }
  if (flagsub)			/* not subscriber anywhere */
    _exit(0);
  else
    _exit(99);
}
