#include "strerr.h"
#include "subscribe.h"
#include "log.h"
#include "errtxt.h"

#define FATAL "ezmlm-unsub: fatal: "
#define WARNING "ezmlm-unsub: warning: "

void main(argc,argv)
int argc;
char **argv;
{
  char *dir;
  char *addr;

  (void) umask(022);
  dir = argv[1];
  if (!dir)
    strerr_die1x(100,"ezmlm-unsub: usage: ezmlm-unsub dir box@domain ...");

  if (dir[0] != '/')
    strerr_die2x(100,FATAL,ERR_SLASH);

  argv += 2;
  while (addr = *argv++)
    if (subscribe(dir,addr,0,FATAL))
      log(dir,"-manual",addr);
  _exit(0);
}
