#include "error.h"
#include "strerr.h"
#include "readwrite.h"
#include "str.h"
#include "stralloc.h"
#include "open.h"
#include "substdio.h"
#include "case.h"
#include "errtxt.h"
#include "subscribe.h"
#include "qmail.h"

static substdio ssin;
static char inbuf[1024];
static struct qmail *q;
static stralloc line = {0};
static stralloc fnsub = {0};

static void die_nomem(fatal)
char *fatal;
{
  strerr_die2x(111,fatal,ERR_NOMEM);
}

static int mywrite(fd,buf,len)
  int fd;
  char *buf;
  unsigned int len;

{
  qmail_put(q,buf,len);
  return (int) len;
}



void tosubs(dbname,userhost,qq,FATAL)
/* Outputs all userhostesses in 'dbname' to qmail. If userhost is not null */
/* that userhost is excluded Here 'dbname' is the base directory name.     */

char *dbname;
char *userhost;
struct qmail *qq;
char *FATAL;

{
  int i;
  int fd;
  int match;
  unsigned int len = 0;
  unsigned int hashpos;
  int flagself = 0;		/* = 1 if we can copy subscriber db directly */
				/* requires that we don't want to exclude    */
				/* self and that the MTA is qmail */

  q = qq;			/* local pointer so mywrite works */

  if (!userhost || !*userhost)
    flagself = 1;		/* can just copy the subscriber files*/
  else
    len = str_len(userhost)+2;	/* Tuserhost@host\0  used only if !flagself */

  if (!stralloc_copys(&fnsub,dbname)) die_nomem(FATAL);
  if (!stralloc_catb(&fnsub,"/subscribers/?",15)) die_nomem(FATAL);
		  		/* NOTE: Also copies terminal '\0' */
  hashpos = fnsub.len - 2;
  for (i = 0;i < 53;++i) {
    fnsub.s[hashpos] = 64 + i;
    fd = open_read(fnsub.s);
    if (fd == -1) {
      if (errno != error_noent)
	strerr_die4sys(111,FATAL,ERR_READ,fnsub.s,": ");
    } else {
      substdio_fdbuf(&ssin,read,fd,inbuf,sizeof(inbuf));
      for (;;) {
        if (getln(&ssin,&line,&match,'\0') == -1)
	    strerr_die4sys(111,FATAL,ERR_READ,fnsub.s,": ");
        if (!match)
          break;
        if (flagself ||
		(line.len != len) || case_diffb(userhost,len-2,line.s+1))
           qmail_to(qq,line.s+1);
      } 
      close(fd);
    }
  }
}

